SET SERVEROUTPUT ON;

/*------------------------*
 *     PROVES ABM         *
 *----------------------- */
/
set echo on
spool proves.log

---------------------------
--USUARIS   -- ALTA USUARIS
---------------------------



DECLARE

   RSP VARCHAR2(500);

BEGIN

 	

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: ALTA_USUARI ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("TS"."USUARIS"."NMOBIL")

	SP_ALTA_USUARIS(NULL, 'VODAFONE ESPANA', 12, 'operez@gmail.com',   RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 


-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: ALTA_USUARI ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (TS.USUARIS_PAIS_FK) violated - parent key not found

	
      SP_ALTA_USUARIS('699111111', 'VODAFONE ESPANA', 50, 'operez@gmail.com',   RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 

--  ALTA CORRECTA
--  RSP: OK
SP_ALTA_USUARIS('699111133', 'ORANGE', 12, 'mlloret@gmail.com',   RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
	
      COMMIT;

END;
/

----------------------------------
--USUARIS   -- MODIFICACIO USUARIS
----------------------------------


DECLARE

   RSP VARCHAR2(500);
   N NUMBER;

BEGIN

      SELECT idusuari INTO N FROM USUARI WHERE NMOBIL= '699111115';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 

-- ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL
-- RSP: MODIFICACIO_USUARI  ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL  1: User-Defined Exception

  	SP_MODIFICACIO_USUARIS(NULL, 'VODAFONE ESPANA', 12, 'operez@gmail.com',   RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
		
-- ERROR: L'USUARI  NO EXISTEIX
-- RSP: MODIFICACIO_USUARI ERROR: USUARI NO EXISTEIX 100: ORA-01403: no data found

	 SP_MODIFICACIO_USUARIS(9999999, 'VODAFONE ESPANA', 12, 'operez@gmail.com',   RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
 
-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: MODIFICACIO_USUARI ERROR ! -1407: ORA-01407: cannot update ("APPS"."USUARIS"."NIF") to NULL

	SP_MODIFICACIO_USUARIS('699111111', 'VODAFONE ESPANA', NULL, 'operez@gmail.com',   RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: MODIFICACIO_USUARI ERROR: PAIS DE REGISTRE INCORRECTE 1: User-Defined Exception

	 SP_MODIFICACIO_USUARIS(NULL, 'VODAFONE ESPANA', 60, 'operez@gmail.com',   RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);

--  MODFICACIO CORRECTA
--  RSP: OK
	
       UPDATE USUARI SET nmobil=p_nmobil WHERE nmobil = N;
	 COMMIT;
	 SP_MODIFICACIO_USUARIS(NULL, 'ORANGE ESPANA', 12, 'operez@gmail.com',   RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);


	
END;
/
----------------------------------
--USUARIS   -- BAIXA USUARIS
----------------------------------

-- PARAMETRES ENTRADA:  p_nmobil
DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   X NUMBER;
   P NUMBER;	
BEGIN

      SELECT nmobil INTO N FROM USUARI WHERE NMOBIL= '699111117';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 

-- ERROR: EL PARAMETRE ENTRADA NMOBIL NO POT SER NULL
-- RSP: BAIXA_USUARI  ERROR: EL PARAMETRE ENTRADA NMOBIL NO POT SER NULL 1: User-Defined Exception

	SP_BAIXA_USUARIS(NULL,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: USUARI NO EXISTEIX
-- RSP: BAIXA_USUARI  ERROR: USUARI NO EXISTEIX 100: ORA-01403: no data found

	SP_BAIXA_USUARIS(99999,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);


-- BAIXA CORRECTA USUARI SENSE DESCARREGUES ASSOCIADES (ESBORRA DE LA TAULA USUARIS)
-- RSP: OK

	SP_BAIXA_USUARIS(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- DESENVOLUPADOR   -- ALTA DESENVOLUPADOR   
-------------------------------------------


DECLARE

   RSP VARCHAR2(500);

BEGIN

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: ALTA_DESENVOLUPADOR ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("TS"."DESENVOLUPADORS"."NOM")

   SP_ALTA_DESENVOLUPADORS(1, NULL, 'Juan Ramon',12, 'AV.Manoteras,3', '911232976', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   
-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: ALTA_DESENVOLUPADOR ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (TS.DESENVOLUPADORS_PAIS_FK) violated - parent key not found

   SP_ALTA_DESENVOLUPADORS(1, 'APPDevelopers', 'Juan Ramon',60, 'AV.Manoteras,3', '911232976', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);


-- ALTA CORRECTA
-- RSP: OK

   SP_ALTA_DESENVOLUPADORS(9, 'PPPPP', 'Juan ',12, 'RIAL,2', '91787893', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--------------------------------------------------
-- DESENVOLUPADOR   -- MODIFICACIO DESENVOLUPADOR   
--------------------------------------------------



DECLARE

   RSP VARCHAR2(500);
   N NUMBER;

BEGIN

   SELECT idDesenvolupador INTO N FROM DESENVOLUPADOR WHERE nom ='eNubes';
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL
-- RSP: MODIF_DESENVOLUPADOR ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL  1: User-Defined Exception

	   SP_MODIFICACIO_DESENVOLUPADORS (NULL, 'eNubes', 'Rosa Maria',12, 'Paseo de la Riconada, 9', '913571400', RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);


-- ERROR: QUE EL DESENVOLUPADOR NO EXISTEIXI
-- RSP: MODIF_DESENVOLUPADOR ERROR: EL DESENVOLUPADOR NO EXISTEIX 100: ORA-01403: no data found
	   
	   SP_MODIFICACIO_DESENVOLUPADORS (99999, 'eNubes', 'Rosa Maria',12, 'Paseo de la Riconada, 9', '913571400', RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);
		
-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: MODIF_DESENVOLUPADOR ERROR ! -1407: ORA-01407: cannot update ("TS"."DESENVOLUPADORS"."NOM") to NULL

	  SP_MODIFICACIO_DESENVOLUPADORS (N, NULL, 'Rosa Maria',12, 'Paseo de la Riconada, 9', '913571400', RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: MODIF_DESENVOLUPADOR ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (TS.DESENVOLUPADORS_PAIS_FK) violated - parent key not found

	 SP_MODIFICACIO_DESENVOLUPADORS (N, 'eNubes', 'Rosa Maria',50, 'Paseo de la Riconada, 9', '913571400', RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);


--  MODIFICACIO CORRECTA
--  RSP: OK

    	UPDATE DESENVOLUPADOR 
  	 SET nom = p_nom, 
      	 nomRepresentant = p_nomRepresentant,
         pais = p_pais,
      	 adreca= p_adreca,
         telefon = p_telefon
   	 WHERE idDesenvolupador = p_idDesenvolupador;
     
         COMMIT;	

       SP_MODIFICACIO_DESENVOLUPADORS (N, 'eNubes', 'Rosa Maria',1, 'Paseo de la Riconada, 9', '913571400', RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);
	 COMMIT;

END;
/

----------------------------------------------
--DESENVOLUPADOR   -- BAIXA DESENVOLUPADOR   
----------------------------------------------

--    PARAMETRES ENTRADA:  p_idDesenvolupadors

DECLARE

   RSP VARCHAR2(500);
   N  NUMBER;
BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL
-- RSP: BAIXA_DESENVOLUPADORS  ERROR: EL PARAMETRE ENTRADA NO POT SER NULL  -1400: ORA-01400: cannot insert NULL into ()

      SP_BAIXA_DESENVOLUPADORS(NULL,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);


-- ERROR: DESENVOLUPADOR NO EXISTEIX
-- RSP: BAIXA_DESENVOLUPADORS  ERROR: EL DESENVOLUPADOR NO EXISTEIX 100: ORA-01403: no data found

      SP_BAIXA_DESENVOLUPADORS(99999,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DESENVOLUPADOR (ESBORRA DE LA TAULA DESENVOLUPADOR )
-- RSP: OK

      SP_BAIXA_DESENVOLUPADORS(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
      


END;
/

-------------------------------------------
-- APLICACIONS       -- ALTA APLICACIONS
-------------------------------------------


DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: ALTA_APLICACIONS  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (TS.APLICACIOS_SISTEMAOPERATIU_FK) violated - parent key not found

   SP_ALTA_APLICACIONS('1','1', '1/1/10',  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 



-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: _ALTA_APLICACIONS  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("TS"."APLICACIONS"."VERSIO")

   SP_ALTA_APLICACIONS(NULL,'1', '1/1/10',  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 



-- ALTA CORRECTA
-- RSP: OK
   
   SP_ALTA_APLICACIONS('1','3', '1/1/10',  'URL', '200X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  



END;
/

---------------------------------------------
-- APLICACIONS     -- MODIFICACIO APLICACIONS
---------------------------------------------

-- PARAMETRES ENTRADA:  P_idAplicacio, p_versio, p_dat, p_desenvolupadors, p_sistemaOperatiu, p_enllacbinari, p_mida, p_descripcio, p_url, p_resolucio, p_activa

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   IDCAT NUMBER;
BEGIN

      
-- ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL
-- RSP: MODIFiCACIO_APLICACIONS  ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL  1: User-Defined Exception

   SP_MODIFICACIO_APLICACIONS(NULL,'1', '1/1/10',  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 

-- ERROR: QUE  APLICACIO NO EXISTEIXI
-- RSP: MODIFICACIO_APLICACIO  ERROR: APLICACIO NO EXISTEIX 100: ORA-01403: no data found

   SP_MODIFICACIO_APLICACIONS('99999','1', '1/1/10',  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 



-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR ! -1407: ORA-01407: cannot update ("TS"."APLICACIONS"."SISTEMAOPERATIU") to NULL

   
   SP_MODIFICACIO_APLICACIONS('1','1', NULL,  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
   
   
-- MODIFICACIO CORRECTA
-- RSP: OK
   
   SP_MODIFICACIO_APLICACIONS('1','2', '1/1/10',  'URL', '100X200', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 


END;
/


-------------------------------------------
-- APLICACIONS     -- BAIXA APLICACIONS
-------------------------------------------

--    PARAMETRES ENTRADA:  p_idAplicacio

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL
-- RSP: BAIXA_APLICACIONS  ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL  1: User-Defined Exception

   SP_BAIXA_APLICACIONS(NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: APLICACIO NO EXISTEIX
-- RSP:BAIXA_APLICACIONS  ERROR: APLICACIO NO EXISTEIX 100: ORA-01403: no data found	    

   SP_BAIXA_APLICACIONS(99999,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA APLICACIO SENSE PRODUCTES ASSOCIATS (ESBORRA DE LA TAULA APLICACIO )
-- RSP: OK

   SP_BAIXA_APLICACIONS(N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
END;
/


/**************************
     PROVES CONSULTES       
**************************/ 

DECLARE
  RSP VARCHAR2(500);
  REFCURSOR SYS_REFCURSOR;
  nmobil NUMBER;
  idDesenvolupador NUMBER;
  operador VARCHAR2(20);
  correu VARCHAR2(40);
  pais CHAR(2); 
  num NUMBER;
  identificador VARCHAR2(40);
  ver VARCHAR2(20);
  dataPujada DATE;
  resolucio VARCHAR2(20);
  idAplicacio VARCHAR2(40);
  aplicacio VARCHAR2(40);
  versio VARCHAR2(20);
  modelDispositiu NUMBER(15);
  dataDesc DATE;
  modePagament VARCHAR2(22);
  preu NUMBER;
  usuari NUMBER;
  suma INTEGER;
  nom  VARCHAR2(50);
  adreca VARCHAR2(75);
  anyo NUMBER(4);
  telefon NUMBER;
BEGIN

/* 
CONSULTA_LLISTAT_APLICACIONS
*/

 FU_LLISTAT_APLICACIONS( REFCURSOR, RSP);
WHILE REFCURSOR%FOUND
LOOP
FETCH REFCURSOR INTO idAplicacio,versio, dataPujada, resolucio,num;
DBMS_OUTPUT.PUT_LINE(idAplicacio||', '||versio||', '||dataPujada||', '||resolucio||', '||to_char(num));
END LOOP;
CLOSE REFCURSOR;

/* 
CONSULTA_LLISTAT_DESENVOLUPADOR
*/

  FU_LLISTAT_DESENVOLUPADOR('12',REFCURSOR, RSP);

 WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO idDesenvolupador,nom,adreca,telefon,num;
    DBMS_OUTPUT.PUT_LINE(idDesenvolupador||', '||nom||', '||adreca||', '||to_char(telefon)||', '||to_char(num));
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_LLISTAT_PASOS_APLICACIO
*/

  FU_LLISTAT_PAISOS_APLICACIO('A4', 2012, REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO pais,num;
    DBMS_OUTPUT.PUT_LINE(aplicacio||', '||to_char(anyo)||', '||pais||', '||to_char(num));
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_LLISTAT_USUARIS_ACTIVITAT
*/

  FU_LLISTAT_USUARIS_ACTIVITAT(699111111, REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO aplicacio, modelDispositiu,usuari,pais,dataDesc,modePagament,preu,operador;
    DBMS_OUTPUT.PUT_LINE(aplicacio||', '||to_char(modelDispositiu)||', '||to_char(usuari)||', '||pais||', '||to_char(dataDesc)||', '||modePagament||', '||to_char(preu)||', '||operador);
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_TOP20_USUARIS
*/

  FU_TOP20_USUARIS(2012, REFCURSOR, RSP);
  
  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO usuari,suma;
    DBMS_OUTPUT.PUT_LINE(anyo||', '||to_char(usuari)||', '||to_char(suma));
  END LOOP;
  CLOSE REFCURSOR;

END;






/*****************************
     PROVES ESTADISTIQUES        
*****************************/ 


DECLARE
   RSP VARCHAR2(200);
   num_desc NUMBER;
   recapt NUMBER;
   anyDescarrega NUMBER(4);
   med_desc NUMBER;
   desenv NUMBER;
   apl VARCHAR2(40);
   pais CHAR(2);
   num_usr NUMBER;
   ingres NUMBER;
   apl_desc NUMBER;
BEGIN
-- EST1

SELECT * INTO num_desc FROM EST1_NUMTOTALDESCARREGUES;
DBMS_OUTPUT.PUT_LINE(to_char(num_desc));

SP_BAIXA_DESCARREGUES('A1', 111111111111111, RSP);

SELECT * INTO num_desc FROM EST1_NUMTOTALDESCARREGUES;
DBMS_OUTPUT.PUT_LINE(to_char(num_desc));


-- EST2

SELECT * INTO recapt FROM EST2_TOTALEUROSDESC;
DBMS_OUTPUT.PUT_LINE(to_char(recapt));

SP_ALTA_DESCARREGUES('A1', 111111111111111, TO_DATE ('27/10/2011'), 'paypal', 3.5, '1', RSP);

SELECT * INTO recapt FROM EST2_TOTALEUROSDESC;
DBMS_OUTPUT.PUT_LINE(to_char(recapt));


-- EST3. 

SELECT * INTO anyDescarrega, med_desc FROM EST3_NMIGAPLICUSUARI WHERE anyDescarrega=2011;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(med_desc));

SELECT * INTO anyDescarrega, med_desc FROM EST3_NMIGAPLICUSUARI WHERE anyDescarrega=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(med_desc));

SELECT * INTO anyDescarrega, med_desc FROM EST3_NMIGAPLICUSUARI WHERE anyDescarrega=2010;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(med_desc));


-- EST4

SELECT * INTO anyDescarrega, desenv, num_desc FROM EST4_MAXDESCARREGUES WHERE anyDescarrega=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(desenv)||', '||to_char(num_desc));

SELECT * INTO anyDescarrega, desenv, num_desc FROM EST4_MAXDESCARREGUES WHERE anyDescarrega=2011;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(desenv)||', '||to_char(num_desc));


-- EST5. 

SELECT * INTO anyDescarrega, apl, desenv FROM EST5_APLICMESRECAPTACIO WHERE anyDescarrega=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(apl)||', '||to_char(desenv));

SELECT * INTO anyDescarrega, apl, desenv FROM EST5_APLICMESRECAPTACIO WHERE anyDescarrega=2010;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||to_char(apl)||', '||to_char(desenv));


-- EST6
SELECT * INTO anyDescarrega, pais, num_usr FROM EST6_NUMEROUSUARISDIFERENTS WHERE anyDescarrega=2011 AND pais=12;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(num_usr));

SELECT * INTO anyDescarrega, pais, num_usr FROM EST6_NUMEROUSUARISDIFERENTS WHERE anyDescarrega=2012 AND pais='11';
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(num_usr));


-- EST7

SELECT * INTO anyDescarrega, pais, ingres FROM EST7_INGRESSOSUSUARISPAIS WHERE anyDescarrega=2011 AND pais=12;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(ingres));

SELECT * INTO anyDescarrega, pais, ingres FROM EST7_INGRESSOSUSUARISPAIS WHERE anyDescarrega=2012 AND pais='FR';
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(ingres));


--EST8

SELECT * INTO anyDescarrega, pais, apl_desc FROM EST8_APLICDIFDESC WHERE anyDescarrega=2012 AND pais='12';
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(apl_desc));

SELECT * INTO anyDescarrega, pais, apl_desc FROM EST8_APLICDIFDESC WHERE anyDescarrega=2012 AND pais=11;
DBMS_OUTPUT.PUT_LINE(to_char(anyDescarrega)||', '||pais||', '||to_char(apl_desc));


END;




-------------------
--TAULA LOG1--
-------------------
/
SELECT * FROM LOG1 ORDER BY 1;
/
spool off
exit


